---
title: ParentNode.childElementCount
slug: Web/API/ParentNode/childElementCount
tags:
  - API
  - DOM
  - ParentNode
  - Property
  - Reference
---
<div>{{ APIRef("DOM") }}</div>

<p>The <code><strong>ParentNode.childElementCount</strong></code> read-only property returns an <code>unsigned long</code> representing the number of child elements of the given element.</p>

<div class="note">
<p>This property was initially defined in the {{domxref("ElementTraversal")}} pure interface. As this interface contained two distinct set of properties, one aimed at {{domxref("Node")}} that have children, one at those that are children, they have been moved into two separate pure interfaces, {{domxref("ParentNode")}} and {{domxref("ChildNode")}}. In this case, <code>childElementCount</code> moved to {{domxref("ParentNode")}}. This is a fairly technical change that shouldn't affect compatibility.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <var>count</var> = <em>node</em>.childElementCount;
</pre>

<dl>
 <dt><code>count</code></dt>
 <dd>The return value, which is an <code>unsigned long</code> (an integer) type.</dd>
 <dt><code>node</code></dt>
 <dd>An object representing a {{domxref("Document")}}, {{domxref("DocumentFragment")}}, or {{domxref("Element")}}.</dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush:js">var foo = document.getElementById('foo');
if (foo.childElementCount &gt; 0) {
  // Do something
}
</pre>

<h2 id="Polyfill_for_IE8_IE9_Safari">Polyfill for IE8 &amp; IE9 &amp; Safari</h2>

<p>This property is completely unsupported prior to IE9. In IE9 and Safari, it is unsupported in the <code>Document</code> and <code>DocumentFragment</code> objects.</p>

<pre class="brush:js">;(function(constructor) {
  if (constructor &amp;&amp;
      constructor.prototype &amp;&amp;
      constructor.prototype.childElementCount == null) {
    Object.defineProperty(constructor.prototype, 'childElementCount', {
      get: function() {
        var i = 0, count = 0, node, nodes = this.childNodes;
        while (node = nodes[i++]) {
          if (node.nodeType === 1) count++;
        }
        return count;
      }
    });
  }
})(window.Node || window.Element);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-parentnode-childelementcount', 'ParentNode.childElementCount')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td>Split the <code>ElementTraversal</code> interface in {{domxref("ChildNode")}} and <code>ParentNode</code>. This method is now defined on the latter.<br>
    The {{domxref("Document")}} and {{domxref("DocumentFragment")}} implemented the new interfaces.</td>
  </tr>
  <tr>
   <td>{{SpecName('Element Traversal', '#attribute-childElementCount', 'ElementTraversal.childElementCount')}}</td>
   <td>{{Spec2('Element Traversal')}}</td>
   <td>Added its initial definition to the <code>ElementTraversal</code> pure interface and use it on {{domxref("Element")}}.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ParentNode.childElementCount")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{domxref("ParentNode")}} and {{domxref("ChildNode")}} pure interfaces.</li>
 <li>
  <div class="syntaxbox">Object types implementing this pure interface: {{domxref("Document")}}, {{domxref("Element")}}, and {{domxref("DocumentFragment")}}.</div>
 </li>
</ul>
